# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: monster.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Monster(betterproto.Message):
    name: str = betterproto.string_field(1)
    id: int = betterproto.int32_field(2)
    player_id: int = betterproto.int32_field(3)
    battle_values: "BattleValues" = betterproto.message_field(4)
    body_values: "BodyValues" = betterproto.message_field(5)
    last_update: datetime = betterproto.message_field(8)
    is_test: bool = betterproto.bool_field(10)
    activity: "Activity" = betterproto.message_field(6)
    status: "StatusFlags" = betterproto.message_field(7)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class StatusFlags(betterproto.Message):
    is_alive: bool = betterproto.bool_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BattleValues(betterproto.Message):
    attack: int = betterproto.int32_field(1)
    defense: int = betterproto.int32_field(2)
    max_hp: int = betterproto.int32_field(3)
    remaining_hp: int = betterproto.int32_field(4)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BodyValues(betterproto.Message):
    remaining_saturation: float = betterproto.double_field(1)
    max_saturation: float = betterproto.double_field(2)
    mass: int = betterproto.int32_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Activity(betterproto.Message):
    quest_id: "_common__.QuestId" = betterproto.message_field(1, group="activity")
    battle_id: "_common__.BattleId" = betterproto.message_field(2, group="activity")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AddMonCall(betterproto.Message):
    mon: "Monster" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetMonByIdCall(betterproto.Message):
    id: "_common__.MonId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetMonByUserIdCall(betterproto.Message):
    user_id: "_common__.UserId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class UpdateMonCall(betterproto.Message):
    mon: "Monster" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DeleteMonCall(betterproto.Message):
    id: "_common__.MonId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LockRequest(betterproto.Message):
    id: "_common__.MonId" = betterproto.message_field(1)
    activity: "Activity" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ReleaseRequest(betterproto.Message):
    id: "_common__.MonId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonsterDeletedEvent(betterproto.Message):
    mon_id: "_common__.MonId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonsterAddedEvent(betterproto.Message):
    mon: "Monster" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonsterUpdatedEvent(betterproto.Message):
    mon: "Monster" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonsterEvent(betterproto.Message):
    added_event: "MonsterAddedEvent" = betterproto.message_field(1, group="event")
    delete_event: "MonsterDeletedEvent" = betterproto.message_field(2, group="event")
    update_event: "MonsterUpdatedEvent" = betterproto.message_field(3, group="event")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonServiceCall(betterproto.Message):
    add_mon: "AddMonCall" = betterproto.message_field(1, group="method")
    getby_id: "GetMonByIdCall" = betterproto.message_field(2, group="method")
    getbyuser_id: "GetMonByUserIdCall" = betterproto.message_field(3, group="method")
    update: "UpdateMonCall" = betterproto.message_field(4, group="method")
    delete: "DeleteMonCall" = betterproto.message_field(5, group="method")
    meta_data: "_common__.MetaData" = betterproto.message_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonsterList(betterproto.Message):
    monsters: List["Monster"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class MonServiceResponse(betterproto.Message):
    id: "_common__.MonId" = betterproto.message_field(1, group="data")
    mon: "Monster" = betterproto.message_field(2, group="data")
    status: "_common__.ResponseStatus" = betterproto.message_field(3, group="data")
    monsters: "MonsterList" = betterproto.message_field(4, group="data")
    meta_data: "_common__.MetaData" = betterproto.message_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


class MonsterServicesStub(betterproto.ServiceStub):
    async def add_mon(
        self,
        *,
        name: str = "",
        id: int = 0,
        player_id: int = 0,
        battle_values: "BattleValues" = None,
        body_values: "BodyValues" = None,
        last_update: datetime = None,
        is_test: bool = False,
        activity: "Activity" = None,
        status: "StatusFlags" = None,
    ) -> "_common__.MonId":

        request = Monster()
        request.name = name
        request.id = id
        request.player_id = player_id
        if battle_values is not None:
            request.battle_values = battle_values
        if body_values is not None:
            request.body_values = body_values
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test
        if activity is not None:
            request.activity = activity
        if status is not None:
            request.status = status

        return await self._unary_unary(
            "/monster.MonsterServices/AddMon", request, _common__.MonId
        )

    async def add_test_mon(self, *, id: int = 0) -> "Monster":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/monster.MonsterServices/AddTestMon", request, Monster
        )

    async def lock_monster(
        self, *, id: "_common__.MonId" = None, activity: "Activity" = None
    ) -> "Monster":

        request = LockRequest()
        if id is not None:
            request.id = id
        if activity is not None:
            request.activity = activity

        return await self._unary_unary(
            "/monster.MonsterServices/LockMonster", request, Monster
        )

    async def release_monster(
        self, *, id: "_common__.MonId" = None
    ) -> "_common__.ResponseStatus":

        request = ReleaseRequest()
        if id is not None:
            request.id = id

        return await self._unary_unary(
            "/monster.MonsterServices/ReleaseMonster", request, _common__.ResponseStatus
        )

    async def get_mon_by_id(self, *, id: int = 0) -> "Monster":

        request = _common__.MonId()
        request.id = id

        return await self._unary_unary(
            "/monster.MonsterServices/GetMonByID", request, Monster
        )

    async def get_mons_by_user_id(self, *, id: int = 0) -> "MonsterList":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/monster.MonsterServices/GetMonsByUserID", request, MonsterList
        )

    async def update_mon(
        self,
        *,
        name: str = "",
        id: int = 0,
        player_id: int = 0,
        battle_values: "BattleValues" = None,
        body_values: "BodyValues" = None,
        last_update: datetime = None,
        is_test: bool = False,
        activity: "Activity" = None,
        status: "StatusFlags" = None,
    ) -> "Monster":

        request = Monster()
        request.name = name
        request.id = id
        request.player_id = player_id
        if battle_values is not None:
            request.battle_values = battle_values
        if body_values is not None:
            request.body_values = body_values
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test
        if activity is not None:
            request.activity = activity
        if status is not None:
            request.status = status

        return await self._unary_unary(
            "/monster.MonsterServices/UpdateMon", request, Monster
        )

    async def delete_mon(self, *, id: int = 0) -> "_common__.ResponseStatus":

        request = _common__.MonId()
        request.id = id

        return await self._unary_unary(
            "/monster.MonsterServices/DeleteMon", request, _common__.ResponseStatus
        )


from .. import common as _common__
